#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
#include <assert.h>
#include <math.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
using namespace std;
int N,M,P;
int board[51][51];

struct Animal {
    int r,c,k,t;
    int num;
    int animal[11][11];
    Animal() {
    }

    Animal(int r, int c, int k, int t, int num) {
        this->r = r;
        this->c = c;
        this->k = k;
        this->t = t;
        this->num = num;
    }

    void setCell(int i, int j, int number) {
        animal[i][j] = number;
    }

    int getCell(int i, int j) {
        return animal[i][j];
    }

    int getT() {
        return t;
    }

    int getK() {
        return k;
    }

    int getNum() {
        return num;
    }

    bool operator <(const Animal& other) const {
        return t < other.t;
    }
};

Animal animals[101];

vector<int> solCheck[101][51][51];
int errorsOnBoard[101][51][51];
int safetyOnBoard[101][51][51];
pair<int,int> solution[101][101];
int errors[101];
int results[101];
int used[101];

void input() {
    scanf("%d %d %d", &N, &M, &P);
    for(int i = 0; i < N; i++) {
        for(int j = 0; j < M; j++) {
            scanf("%d", &board[i][j]);
        }
    }

    for(int i = 0; i < P; i++) {
        int r,c,k,t;
        scanf("%d %d %d %d", &r, &c, &k, &t);
        Animal animal = Animal(r, c, k, t, i);
        animals[i] = animal;
        for(int j = 0; j < r; j++) {
            char a[11];
            scanf("%s", a);
            for(int l = 0; l < c; l++) {
                animals[i].setCell(j, l, a[l] - 48);
            }
        }
    }
    std::sort(animals, animals + P);
    /*for(int i = 0; i < P; i++) {
        cout << animals[i].getK() << " " << animals[i].getT() << " " << animals[i].getNum() << std::endl;
    }*/
}

bool generateInitial(int num) {
    for(int i = 0; i < num; i++) {
//        cout << i << endl;
//        cout << N << " " << M << " " << animals[i].r << " " << animals[i].c << endl;
        int posx = rand() % ((N - animals[i].r) + 1);
        int posy = rand() % ((M - animals[i].c) + 1);
        solution[num][i].first = posx;
        solution[num][i].second = posy;
    }
    return true;
}

void clear(int num) {
    for(int i = 0; i < N; i++) {
        for(int j = 0; j < M; j++) {
            solCheck[num][i][j].clear();
            errorsOnBoard[num][i][j] = 0;
        }
    }

    for(int i = 0; i < P; i++) {
        errors[i] = 0;
        results[i] = 0;
    }
}

pair<int, int> data[101];

int getErrors(vector<int> &sol, int i, int j) {
    vector<int>::iterator it;
    int size = 0;
    for(it = sol.begin(); it != sol.end(); it++) {
        data[size] = (std::make_pair(animals[(*it)].getK(), animals[(*it)].getT()));
        size++;
    }

    std::sort(data, data + size);

    int errors = 0;

    int safety = board[i][j];

    for(int k = 0; k < size; k++) {
        if(data[k].second > safety) {
            errors++;
        }

        safety /= data[k].first;
    }

    return errors;
}

int getSafety(vector<int> &sol, int i, int j) {
    vector<int>::iterator it;
    int size = 0;
    for(it = sol.begin(); it != sol.end(); it++) {
        data[size] = (std::make_pair(animals[(*it)].getK(), animals[(*it)].getT()));
        size++;
    }

    std::sort(data, data + size);

    int safetyRes = 0;

    int safety = board[i][j];

    for(int k = 0; k < size; k++) {
        safetyRes += safety;
        safety /= data[k].first;
    }

    return safetyRes;
}


int getIterations() {
    return 200;
}

void placeAnimal(int animal, int num, int x, int y, bool errorsOnly) {
    for(int j = 0; j < animals[animal].r; j++) {
        for(int k = 0; k < animals[animal].c; k++) {
            if(animals[animal].getCell(j, k)) {
                solCheck[num][x + j][y + k].push_back(animal);
                errorsOnBoard[num][x + j][y + k] = getErrors(solCheck[num][x + j][y + k], x + j , y + k);
                if(!errorsOnly) {
                    safetyOnBoard[num][x + j][y + k] = getSafety(solCheck[num][x + j][y + k], x + j , y + k);
                }
            }
        }
    }
}

void removeAnimal(int animal, int num, int x, int y, bool errorsOnly) {
    for(int j = 0; j < animals[animal].r; j++) {
        for(int k = 0; k < animals[animal].c; k++) {
            if(animals[animal].getCell(j, k)) {
                solCheck[num][x + j][y + k].erase(find(solCheck[num][x + j][y + k].begin(), solCheck[num][x + j][y + k].end(), animal));
                errorsOnBoard[num][x + j][y + k] = getErrors(solCheck[num][x + j][y + k], x + j , y + k);
                if(!errorsOnly) {
                    safetyOnBoard[num][x + j][y + k] = getSafety(solCheck[num][x + j][y + k], x + j , y + k);
                }
            }
        }
    }
}

int getErrorsFor(int x, int y, int num, int animal) {
    int errorsNum = 0;
    int r = animals[animal].r;
    int c = animals[animal].c;
    for(int i = 0; i < r; i++) {
        for(int j = 0; j < c; j++) {
            if(animals[animal].getCell(i, j)) {
                errorsNum += errorsOnBoard[num][x + i][y + j];
            }
        }
    }

    return errorsNum;
}

int getSafetyFor(int x, int y, int num, int animal) {
    int safety = 0;
    int r = animals[animal].r;
    int c = animals[animal].c;
    for(int i = 0; i < r; i++) {
        for(int j = 0; j < c; j++) {
            if(animals[animal].getCell(i, j)) {
                safety += safetyOnBoard[num][x + i][y + j];
            }
        }
    }

    return safety;
}

void place(int num) {
    clock_t begin = clock();
//    cout << "Before generating initial values" << endl;
    if(!generateInitial(num)) {
        errors[num] = 10000000;
        return;
    }

//    cout << "After generating initial values" << endl;

    clear(num);
    for(int i = 0; i < num; i++) {
        placeAnimal(i, num, solution[num][i].first, solution[num][i].second, true);
    }

    for(int i = 0; i < N; i++) {
        for(int j = 0; j < M; j++) {
            errors[num] += errorsOnBoard[num][i][j];
        }
    }

    int iterations = getIterations();

    if(errors[num] == 0) {
        return;
    }

//    cout << "Before iterations" << endl;
    while(iterations > 0 && (clock() - begin) < 10000) {
        iterations--;
        /*for(int i = 0; i < N; i++) {
            for(int j = 0; j < M; j++) {
                cout << errorsOnBoard[num][i][j] << " ";
            }
            cout << endl;
        }*/

        int animal = rand() % num;
        int x = solution[num][animal].first;
        int y = solution[num][animal].second;
        int errorsBefore = getErrorsFor(x, y, num, animal);
        //cout << x << " " << y << " " << animals[animal].r << " " << animals[animal].c << endl;
        //cout << iterations << " ---------> " << errors[num] << std::endl;
        int bestErrors = errorsBefore;
        int bestX = x;
        int bestY = y;
        removeAnimal(animal, num, x, y, true);
        errorsBefore = errorsBefore - getErrorsFor(x, y, num, animal);
        for(int i = 0; i < N - animals[animal].r; i++) {
            for(int j = 0; j < M - animals[animal].c; j++) {
                placeAnimal(animal, num, i, j, true);
                int errorsTemp = getErrorsFor(i, j, num, animal);
                removeAnimal(animal, num, i, j, true);
                errorsTemp = errorsTemp - getErrorsFor(i, j, num, animal);
                if(errorsTemp < bestErrors) {
                    bestX = i;
                    bestY = j;
                    bestErrors = errorsTemp;
                }
            }
        }

//        cout << errorsBefore << " " << bestErrors << std::endl;
//        cout << bestX << " " << bestY << endl;
        errors[num] -= errorsBefore;
        placeAnimal(animal, num, bestX, bestY, true);
        errors[num] += bestErrors;
        solution[num][animal].first = bestX;
        solution[num][animal].second = bestY;
        //cout << num << " " << errors[num] << endl;
        assert(errors[num] >= 0);
        if(errors[num] == 0) {
            return;
        }
    }
}

void optimize(int num) {
    clock_t begin = clock();
    clear(num);
    for(int i = 0; i < num; i++) {
        placeAnimal(i, num, solution[num][i].first, solution[num][i].second, false);
    }

    for(int i = 0; i < N; i++) {
        for(int j = 0; j < M; j++) {
            errors[num] += errorsOnBoard[num][i][j];
            results[num] += safetyOnBoard[num][i][j];
        }
    }

    int iterations = 600;

//    cout << "Before iterations" << endl;
    while(iterations > 0 && (clock() - begin) < 100000) {
        iterations--;
        /*for(int i = 0; i < N; i++) {
            for(int j = 0; j < M; j++) {
                cout << errorsOnBoard[num][i][j] << " ";
            }
            cout << endl;
        }*/

        int animal = rand() % num;
        int x = solution[num][animal].first;
        int y = solution[num][animal].second;
        int errorsBefore = getErrorsFor(x, y, num, animal);
        int safetyBefore = getSafetyFor(x, y, num, animal);
        //cout << x << " " << y << " " << animals[animal].r << " " << animals[animal].c << endl;
        //cout << iterations << " ---------> " << errors[num] << std::endl;
        int bestSafety = safetyBefore;
        int bestX = x;
        int bestY = y;
        removeAnimal(animal, num, x, y, false);
        errorsBefore = errorsBefore - getErrorsFor(x, y, num, animal);
        safetyBefore = safetyBefore - getSafetyFor(x, y, num, animal);
        for(int i = 0; i < N - animals[animal].r; i++) {
            for(int j = 0; j < M - animals[animal].c; j++) {
                placeAnimal(animal, num, i, j, false);
                int errorsTemp = getErrorsFor(i, j, num, animal);
                int safetyTemp = getSafetyFor(i, j, num, animal);
                removeAnimal(animal, num, i, j, false);
                errorsTemp = errorsTemp - getErrorsFor(i, j, num, animal);
                if(errorsTemp > 0) {
                    continue;
                }
                safetyTemp = safetyTemp - getSafetyFor(i, j, num, animal);
                if(bestSafety < safetyTemp) {
                    bestX = i;
                    bestY = j;
                    bestSafety = safetyTemp;
                }
            }
        }

//        cout << errorsBefore << " " << bestErrors << std::endl;
//        cout << bestX << " " << bestY << endl;
        results[num] -= safetyBefore;
        placeAnimal(animal, num, bestX, bestY, false);
        results[num] += bestSafety;
        solution[num][animal].first = bestX;
        solution[num][animal].second = bestY;
        //cout << num << " " << errors[num] << endl;
        assert(errors[num] >= 0);
        if(errors[num] == 0) {
            return;
        }
    }
}

void show(int num) {
    cout << num << endl;
    cout << errors[num] << std::endl;
    for(int i = 0; i < num; i++) {
        cout << animals[i].num << " " << solution[num][i].first << " " << solution[num][i].second << std::endl;
    }
}

void checkAgain(int num) {
        for(int i = 0; i < 5; i++) {
            place(num);
            if(errors[num] == 0) {
                break;
            }
        }
}

set<int> graph[101];

pair<int, pair<int, int> > sol[101];

void createGraph(int num) {
    for(int j = 0; j < N; j++) {
        for(int k = 0; k < M; k++) {
            vector<int>::iterator it;
            int size = 0;
            for(it = solCheck[num][j][k].begin(); it != solCheck[num][j][k].end(); it++) {
                sol[size] = (std::make_pair(animals[(*it)].getK(), std::make_pair(animals[(*it)].getT(), (*it))));
                size++;
            }

            std::sort(sol, sol + size);
            for(int l = 0; l < size - 1; l++) {
                graph[sol[l].second.second].insert(sol[l + 1].second.second);
            }
        }
    }
}

int usedSol[101];
int number[101];

void calculateSolution(int num) {
    printf("%d\n", num);
    for(int i = 0; i < num; i++) {
        set<int>::iterator it;
        for(it = graph[i].begin(); it != graph[i].end(); it++) {
            number[(*it)]++;
        }
    }

    for(int i = 0; i < num; i++) {
        int k;
        for(int j = 0; j < num; j++) {
            if(number[j] == 0 && !usedSol[j]) {
                k = j;
            }
        }

        usedSol[k] = 1;
        set<int>::iterator it;
        for(it = graph[k].begin(); it != graph[k].end(); it++) {
            number[(*it)]--;
        }
        printf("%d %d %d\n", animals[k].num + 1, solution[num][k].first + 1, solution[num][k].second + 1);
    }
}

int main() {
    freopen("parash.in", "r", stdin);
    freopen("parash.out", "w", stdout);
    clock_t begin = clock();
    input();
//    cout << "After input" << endl;
    srand(1);
    /*for(int i = 1; i <= P; i++) {
        place(i);
        //show(i);
        //cout << "-----------------" << std::endl;
        /*for(int i = 0; i < N; i++) {
            for(int j = 0; j < M; j++) {
                cout << errorsOnBoard[10][i][j] << " ";
            }
            cout << endl;
        }
    }*/
    int l = 1;
    int r = P;
    int upper = 1;
    while(l <= r && (clock() - begin) < 1000000) {
        int mid = (l + r) / 2;
//        cout << mid << endl;
//        cout << "After place" << endl;
        checkAgain(mid);
        if(errors[mid] == 0) {
            used[mid] = 1;
            upper = mid;
            l = mid + 1;
            continue;
        } else {
            r = mid - 1;
            continue;
        }
    }

    if((clock() - begin) <= 500000) {
        int newUpper = upper;

        for(int i = 0; i < 10 && upper + i < P; i++) {
            checkAgain(i + upper);
            if(errors[i + upper] == 0) {
                newUpper = i + upper;
                used[newUpper] = 1;
            }
        }
        upper = newUpper;
    }
    //cout << P << " " << upper << " " << errors[upper] << std::endl;
    /*for(int i = 0; i < P; i++) {
        cout << i << " --> " << errors[i] << endl;
    }*/
    //printf("Time: %lf\n", double(clock() - begin)/CLOCKS_PER_SEC);
    //if(clock() - begin > 600000) {
    //    cout << "TL" << endl;
    //}

    int maxSafety = 0;
    int maxI = 0;

    for(int i = 1; i <= P; i++) {
        if(used[i]) {
            optimize(i);
            if(results[i] > maxSafety) {
                maxSafety = results[i];
                maxI = i;
            }
        }
    }

    //cout << maxSafety << " " << maxI << endl;
    createGraph(maxI);
    calculateSolution(maxI);
 //   printf("Time: %lf\n", double(clock() - begin)/CLOCKS_PER_SEC);

    return 0;
}
